#!/usr/bin/env python
#
# Demokritos Atom Library and Server
# Copyright (C) 2005-2006 James Tauber
# See GPL file at top of distribution

"""
This creates a simple server with two collections in a single workspace.
The first collection is an entry collection and the second one is a media 
collection.

This server should be sufficient for basic interop testing.
"""

import sys
sys.path.append("lib")

from store import AtomStore
import server

atom_store = AtomStore("http://localhost:8000", "test/REPOS")

workspace = atom_store.create_workspace("Demokritos Test Workspace")

collection1 = atom_store.create_collection("Blog Entry Collection", "/blog", "entry")

collection2 = atom_store.create_collection("Media Collection", "/media", "media")

workspace.add_collection(collection1)
workspace.add_collection(collection2)

server.atom_store = atom_store # @@@ hack for now
server.AtomServer().serve_forever()