#!/usr/bin/env python

import httplib, socket, urlparse

import sys
sys.path.append("../lib")
from app import parse_introspection
from atom import parse_atom


SERVER = "localhost:8000"

def request(server, method, path, body=None, headers=None):
    conn = httplib.HTTPConnection(server)
    try:
        print "trying %s %s to %s" % (method, path, server)
        if body is not None and headers is not None:
            conn.request(method, path, body, headers)
        else:
            conn.request(method, path)
        resp = conn.getresponse()
        conn.close()
        print "got %s %s" % (resp.status, resp.reason)
        return resp
    except socket.error:
        print "got socket error"
        return None

##

collection_href = None

response = request(SERVER, "GET", "/introspection")
if response:
    assert response.status == 200
    doc = response.read()
    service = parse_introspection(doc)
    collection_href = service.workspaces[0].collections[1].href

if collection_href:
    print "getting second collection in first workspace..."

    server, path = urlparse.urlparse(collection_href)[1:3]
     
    response = request(server, "GET", path)
    if response:
        assert response.status == 200
        doc = response.read()
        collection = parse_atom(doc)        
        print "collection:"
        for entry in collection.entries:
            print "\tmember:", entry.title.value
            print "\t\tupdated:", entry.updated.value
            for link in entry.links:
                print "\t\tlink %s: %s" % (link.rel, link.href)
            print "\t\tcontent src = %s" % entry.content.src

raw_input("press return")

##

location = None
        
if collection_href:
    print "POSTing atom to entry collection..."
    
    server, path = urlparse.urlparse(collection_href)[1:3]


    body = file("data/bad-content1.atom").read()
    
    headers = {"Content-type": "application/atom+xml"}
    response = request(server, "POST", path, body, headers)
    if response:
        assert response.status == 400

raw_input("press return")
