#!/usr/bin/env python

import httplib, socket, urllib

import sys
sys.path.append("../lib")
from app import parse_introspection
from atom import parse_atom


SERVER = "localhost:8000"

def urlsplit(url):
    return urllib.splithost(urllib.splittype(url)[1])

def request(server, method, path, body=None, headers=None):
    conn = httplib.HTTPConnection(server)
    try:
        print "trying %s %s to %s" % (method, path, server)
        if body is not None and headers is not None:
            conn.request(method, path, body, headers)
        else:
            conn.request(method, path)
        resp = conn.getresponse()
        conn.close()
        print "got %s %s" % (resp.status, resp.reason)
        return resp
    except socket.error:
        print "got socket error"
        return None

##

print "POSTing image to media collection..."
    
server, path = urlsplit("http://localhost:8000/binary/edit")

body = file("data/beach.jpg").read()

headers = {"Content-type": "image/jpeg", "Title": "A picture of the beach"}
response = request(server, "POST", path, body, headers)
if response:
    assert response.status == 201
    location = response.getheader("Location")
    print "got location:", location
    doc = response.read()
    print doc

    entry = parse_atom(doc)
    assert entry.links[0].rel == "edit"
    metadata_uri = entry.links[0].href
    content_uri = entry.content.src

    print "got metadata uri:", metadata_uri
    print "got content uri:", content_uri

    assert content_uri == location


raw_input("press return")

server, path = urlsplit(metadata_uri)

response = request(server, "GET", path)
if response:
    assert response.status == 200
    print response.getheader("Content-type")
    assert response.getheader("Content-type") == "application/atom+xml"
    print response.read()
