#!/usr/bin/env python

import sys
sys.path.append("../lib")

from store import AtomStore
import server

from atom.model import PlainText, Date, Person, InlineTextContent

atom_store = AtomStore("http://localhost:8000", "REPOS")

workspace = atom_store.create_workspace("Atom Publishing Protocol Example")

collection1 = atom_store.create_collection("Entry Collection", "/blog/edit", "entry")
collection2 = atom_store.create_collection("Media Collection", "/binary/edit", "media")

workspace.add_collection(collection1)
workspace.add_collection(collection2)

atom_store.save_collection(collection1)
atom_store.save_collection(collection2)

server.atom_store = atom_store # @@@ hack for now
server.AtomServer().serve_forever()
